/*
 *  AOrientationClassifier.h
 *  Which Way Is Up Test
 *
 *  Created by Andreas Muller on 10/10/2008.
 *  Copyright 2008 Nanika. All rights reserved.
 *
 */


#ifndef __A_ORIENTATION_CLASSIFIER_H
#define __A_ORIENTATION_CLASSIFIER_H

#import <cmath>
#include <string>
#include <iostream>
#include <vector>
using namespace std; 

enum ADeviceOrientation
{
	DeviceOrientationNormal,
	DeviceOrientationUpsideDown,
	DeviceOrientationSideButtonRight,
	DeviceOrientationSideButtonLeft	
};

class AOrientationClassifier
{
public:
	
	AOrientationClassifier();

	void newAccelerometerData( float _x, float _y, float _z );
	ADeviceOrientation classifyOrientation( float _x, float _y, float _z );
	
	void (*deviceChangedOrientationCallback)( ADeviceOrientation ); 
	bool sentCallbackForThisChange;

	string orientationToString( ADeviceOrientation _orientation );

	ADeviceOrientation prevReading;	
	ADeviceOrientation probableDeviceOrientation;
	ADeviceOrientation currentDeviceOrientation;
	
	int startupPhaseTicks;
	int amountTheSameNeeded;
	
	int currAmountOfIdenticalReading;
	bool identicalReadingsSoFar;
};


#endif //__A_ORIENTATION_CLASSIFIER_H