
#include "App.h"

//some code you might want for use with the Accelerometer 
//#define ACCELEROMETER_FORCE		0.2
//vel.x += ACCELEROMETER_FORCE * ofxAccelerometer.getForce().x * ofRandomuf();
//vel.y += -ACCELEROMETER_FORCE * ofxAccelerometer.getForce().y * ofRandomuf();		// this one is subtracted cos world Y is opposite to opengl Y


//--------------------------------------------------------------
void testApp::setup(){	
	printf("setup()\n");
	
	ofBackground(255, 100, 0);
	ofSetBackgroundAuto(true);
	ofSetFrameRate(60);
	
	// initialize the accelerometer
	ofxAccelerometer.setup();

	// touch events will be sent to this class (testApp)
	ofxMultiTouch.addListener(this);
	
	hello.setup();
	someFont.loadFont("04B_03__.TTF", 6, false, false);
	

}


//--------------------------------------------------------------
void testApp::update(){

	
	for (int i = 0; i < pts.size(); i++){
		pts[i].x += ofRandom(-1.25, 1.25);
		pts[i].y += ofRandom(-1.25, 1.25);
		
		pts[i].y += sin(ofGetElapsedTimef()) * 10;
		
		pts[i].x += cos(ofGetElapsedTimef()) * 10;
		
//		pts[i].y += 30*(1-ofxAccelerometer.getForce().y);
//		
//		pts[i].x += 30*ofxAccelerometer.getForce().x;
		
	}
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].update();
		
		
		particles[i].pos.y += sin(ofGetElapsedTimef()) * 10;
		
		particles[i].pos.x += cos(ofGetElapsedTimef()) * 10;
		
//		particles[i].pos.y += 30*(1-ofxAccelerometer.getForce().y);
//		
//		particles[i].pos.x += 30*ofxAccelerometer.getForce().x;
		
		
	}
	
	followPt.x = 0.96f * followPt.x + 0.04 * mouseX;
	followPt.y = 0.96f * followPt.y + 0.04 * mouseY;
	
	
	// Zach Code start
	for(int i=particles.size()-1;i>=0;i--)
	{
		if(particles[i].life > 60*2)
		{
			particles.erase(particles.begin()+i);
		}
	}
	
	//end zach code
	
	
	
	
}

//--------------------------------------------------------------
void testApp::draw(){
	


	
	
	ofNoFill();
	ofBeginShape();
	for (int i = 0; i < pts.size(); i++){
		ofVertex(pts[i].x, pts[i].y);
	}
	
	ofEndShape();
	
	for (int i = 0; i < pts.size(); i++){
		ofCircle(pts[i].x, pts[i].y, (pts[i].y)*0.15);
		ofSetColor(((pts[i].y)*2), ((pts[i].y)*0.35), 0);
		ofFill();
		
	}
	
	//	for (int i = 0; i < pts.size(); i++){
	//		ofCircle(pts[i].x, pts[i].y, (pts[i].y)*0.2);
	//		ofSetColor(((pts[i].y)*1), ((pts[i].y)*0.25), 0);
	//		ofFill();
	//		
	//	}
	
	
	//	for (int i = 0; i < pts.size(); i++){
	//		ofCircle(pts[i].x, pts[i].y, (pts[i].y)*0.2);
	//		ofSetColor(((pts[i].y)*1), 0, 0);
	//		ofNoFill();
	//		ofEnableSmoothing();
	//		
	//	}
	
	// wireframe circles
	
	//	for (int i = 0; i < pts.size(); i++){
	//		ofCircle(pts[i].x, pts[i].y, (pts[i].y)*0.1);
	//		ofSetColor(((pts[i].y)*1), 0, 0);
	//		ofNoFill();
	//		
	//		ofEnableSmoothing();
	//		
	//	}
	
#pragma mark YOYO	
	
	/*
	 for (int i = 0; i < particles.size(); i++){
	 particles[i].draw();
	 }*/
	ofFill();
	ofEnableAlphaBlending();
	//ofSetColor((ofRandom(0, 255)), (ofRandom(0, 255)), (ofRandom(0, 255)), 50);
	ofSetColor(255, 0, 0, 80);
	
	ofBeginShape();
	for (int i = 0; i < particles
		 .size(); i++){
		ofCircle(particles[i].pos.x, particles[i].pos.y, 10);
		
	}
	
	ofEndShape();
	
	//the interior shape
	
	// lines
	
	ofBeginShape();
	ofNoFill();
	ofSetColor(240, 0, 0);
	ofEnableSmoothing();
	
	for (int i = 0; i < particles.size(); i++){
		ofVertex(particles[i].pos.x, particles[i].pos.y);
	}
	
	ofEndShape();
	
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].pos.x += ofRandom(-5, 5);
		particles[i].pos.y += ofRandom(-5, 5);
		
		//				pts[i].y += sin(ofGetElapsedTimef()) * 5;	
		//				pts[i].x += cos(ofGetElapsedTimef()) * 5;
		
	}
	
	
	//small circle
	
	//	ofNoFill();
	//	for (int i = 0; i < particles.size(); i++){
	//		//ofCircle(particles[i].pos.x, particles[i].pos.y, 3.5);
	//		
	//	}
	
	//ofRect(followPt.x, followPt.y, 4,4);
	
	
	
	
	hello.draw();
	
	
	
	
	/// UI ELEMENTS START
	
	ofPushStyle();
	ofFill();
	ofEnableAlphaBlending();
	ofSetColor(0,0,0,70);	
	ofRect(0, 450, 320, 30);
	ofPopStyle();
	
	
	
//	ofPushStyle();
//	ofFill();
//	ofSetColor(255,123,38);
//	ofRect(300, 460, 10, 10);
//	ofPopStyle();
	
	
	ofPushStyle();
	ofSetColor(255,100,0);
	ofLine(300, 460, 310, 470);
	ofLine(310, 460, 300, 470);
	
	ofPopStyle();
	
	
	
	ofPushStyle();
	
	ofSetColor(255,123,38);
	someFont.drawString("CLEAR", 270,468); //font experiments
	
	someFont.drawString("DOUBLE TAP FOR ABOUT", 10,468); //font experiments
	
	ofPopStyle();

	/// UI ELEMENTS END

}

void testApp::exit() {
	printf("exit()\n");
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){
	
}

// mouse functions are there for backwards compatibility
// they are simply the first finger to touch the screen
// you can omit the mouse functions and just use touch functions
// or omit touch functions and just use mouse functions if you don't need multitouch
//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){

}

//--------------------------------------------------------------
void testApp::mouseReleased(){

}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){

}


//--------------------------------------------------------------
void testApp::touchDown(float x, float y, int touchId, ofxMultiTouchCustomData *data) {

	if(x>290 && x<290+30 && y>450 && y<450+30)
	{
		pts.clear();
		particles.clear();
		
	}
	
}


void testApp::touchMoved(float x, float y, int touchId, ofxMultiTouchCustomData *data) {

	ofPoint myPt;
	myPt.x = x;
	myPt.y = y;
	pts.push_back(myPt);
	
	
//	float dx = x - followPt.x;
//	float dy = y - followPt.y;
	
	for (int i = 0; i < 5; i++){
		particle tempParticle;
		tempParticle.pos.set(x,y);
		tempParticle.vel.set( ofRandom(-1,1), ofRandom(-1,1));
		//	tempParticle.vel.set( dx/80.0, dy/80.0);
		
		particles.push_back(tempParticle);
	}
	
}


void testApp::touchUp(float x, float y, int touchId, ofxMultiTouchCustomData *data) {


}

void testApp::touchDoubleTap(float x, float y, int touchId, ofxMultiTouchCustomData *data) {

	//ofToggleFullscreen();
	
//	pts.clear();
//	particles.clear();
	
	//About hello = new About(); 
	//hello.draw();
	hello.bVisible = !hello.bVisible;
	
	
	
}

